/*
   (c) Massachusetts of Technology, 2003
 */
#ifndef __REALCOMPARE_H_
#define __REALCOMPARE_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_vector.h>
#include <gsl/gsl_linalg.h>
#include <gsl/gsl_blas.h>
#include <math.h>
#include "realIo.h"
#include "bitSet.h"

gsl_matrix *
sumOuterProd(gsl_matrix *a, gsl_matrix *b);

int
moveToCentroid(gsl_matrix *m);

int
rotateMats(gsl_matrix *a, gsl_matrix *b);

double
gsl_matrix_rmsd(gsl_matrix *a, gsl_matrix *b);

double
rmsdCompare(rdh_t *data, int win1, int win2, int L, double *extraParams);

double
generalMatchFactor(rdh_t *data, int win1, int win2, int L, double *extraParams);

double
massSpecCompareWElut(rdh_t *data, int win1, int win2, int L, double *extraParams);

bitGraph_t *
realComparison(rdh_t *data, int l, double g, int compFunc, double* extraParams);

double (*getCompFunc(int compFunc))(rdh_t*,int,int,int,double*);

#endif				
